# Event Scripts RPG Maker 2.0
# Created By:J3ff Hoogland
# Date Started: 01/11/08
# Version .05
# Contact Email:blue_starsoar@yahoo.com

#Name of your RPG Mod
modname = "Dungeons and Dragons Classic"
#Say command values - These var determin what you want the chat commands to be to bring up the menus
#Select a new character while dead
menucommand = "changerace"
#Command players use to see the different skills characters have
characterinfocommand = "raceinfo"
#Command to show the users their Level, Character, and Xp
infocommand = "showxp"
#Shows the helpmenu
helpcommand = "help"
#Displays the a menu to buy items from
shopcommand = "shop"
#Command to bring up information on items
shopinfocommand = "shopinfo"
#Command to see a player's character
playerinfocommand = "playerinfo"
#What character you want your players to get when they join, also the character bots will use
defaultcharacter = "Human"
#Maxium number of items a person can have at one time
maxitems = 4
#Sets the level that a user's save file is safe once obtained when rpg_cleanuserfile is run
safelevel = 3
#These values determin how much Xp you get for certain things
killxp = 6
headshotxp = 4
knifexp = 10
objectivexp = 8
endroundxp = 2
levelinterval = 80
#The list of steamid's in here determines your users whom can access the rpg commands through chat
adminlist = ['STEAM_ID_LAN', 'STEAM_0:0:7663580']

#Do not touch anything below this line! Things may break if you do!
import es, popuplib, playerlib, os.path, cPickle, gamethread, random, rpgmc, rpgshop
from rpgmc import rpgmc
from rpgshop import rpgshop

#Where all of our player data is stored.
Players = {}
idlist = {}

#Begin events for RPGMaker
def player_blind(event_var):
	if Players.has_key(event_var['es_steamid']):
		character = Players[event_var['es_steamid']]['character']
		level = Players[event_var['es_steamid']][character]
		for key in rpgmc[character]['skills']:
			if level >= key:
				if rpgmc[character]['skills'][key]['cfg'] == 'blind':
					es.server.cmd(rpgmc[character]['skills'][key]['cmd'])
		if rpgmc[character].has_key('blind'):
			es.server.cmd(rpgmc[character]['blind'])
		mylist = idlist[event_var['userid']]['items']
		for item in mylist:
			if rpgshop[item]['cfg'] == 'blind':
				es.server.cmd('%s'%rpgshop[item]['cmd'])
def player_say(event_var):
	if Players.has_key(event_var['es_steamid']):
		character = Players[event_var['es_steamid']]['character']
		level = Players[event_var['es_steamid']][character]
		for key in rpgmc[character]['skills']:
			if level >= key:
				if rpgmc[character]['skills'][key]['cfg'] == 'say':
					es.server.cmd(rpgmc[character]['skills'][key]['cmd'])
		if rpgmc[character].has_key('say'):
			es.server.cmd(rpgmc[character]['say'])
		mylist = idlist[event_var['userid']]['items']
		for item in mylist:
			if rpgshop[item]['cfg'] == 'say':
				es.server.cmd('%s'%rpgshop[item]['cmd'])
def player_jump(event_var):
	if Players.has_key(event_var['es_steamid']):
		character = Players[event_var['es_steamid']]['character']
		level = Players[event_var['es_steamid']][character]
		for key in rpgmc[character]['skills']:
			if level >= key:
				if rpgmc[character]['skills'][key]['cfg'] == 'jump':
					es.server.cmd(rpgmc[character]['skills'][key]['cmd'])
		if rpgmc[character].has_key('jump'):
			es.server.cmd(rpgmc[character]['jump'])
		mylist = idlist[event_var['userid']]['items']
		for item in mylist:
			if rpgshop[item]['cfg'] == 'jump':
				es.server.cmd('%s'%rpgshop[item]['cmd'])
def player_death(event_var):
	if int(event_var['attacker']):
		if event_var['es_userteam'] != event_var['es_attackerteam']:
			givexp(event_var['attacker'], killxp, 'killing a player')
			if event_var['headshot'] == '1':
				givexp(event_var['attacker'], headshotxp, 'scoring a headshot')
			if event_var['weapon'] == 'knife':
				givexp(event_var['attacker'], knifexp, 'killing someone with a knife')
	global idlist
	if idlist.has_key(event_var['userid']):
		idlist[event_var['userid']]['deaths'] += 1
		idlist[event_var['userid']]['items'] = []
	if Players.has_key(event_var['es_steamid']):
		character = Players[event_var['es_steamid']]['character']
		level = Players[event_var['es_steamid']][character]
		for key in rpgmc[character]['skills']:
			if level >= key:
				if rpgmc[character]['skills'][key]['cfg'] == 'death':
					es.server.cmd(rpgmc[character]['skills'][key]['cmd'])
		if rpgmc[character].has_key('death'):
			es.server.cmd(rpgmc[character]['death'])
		mylist = idlist[event_var['userid']]['items']
		for item in mylist:
			if rpgshop[item]['cfg'] == 'death':
				es.server.cmd('%s'%rpgshop[item]['cmd'])
	if Players.has_key(event_var['es_attackersteamid']):
		character = Players[event_var['es_attackersteamid']]['character']
		level = Players[event_var['es_attackersteamid']][character]
		for key in rpgmc[character]['skills']:
			if level >= key:
				if rpgmc[character]['skills'][key]['cfg'] == 'kill':
					es.server.cmd(rpgmc[character]['skills'][key]['cmd'])
		if rpgmc[character].has_key('kill'):
			es.server.cmd(rpgmc[character]['kill'])
		mylist = idlist[event_var['userid']]['items']
		for item in mylist:
			if rpgshop[item]['cfg'] == 'kill':
				es.server.cmd('%s'%rpgshop[item]['cmd'])
def player_hurt(event_var):
	if Players.has_key(event_var['es_steamid']):
		character = Players[event_var['es_steamid']]['character']
		level = Players[event_var['es_steamid']][character]
		for key in rpgmc[character]['skills']:
			if level >= key:
				if rpgmc[character]['skills'][key]['cfg'] == 'victim':
					es.server.cmd(rpgmc[character]['skills'][key]['cmd'])
		if rpgmc[character].has_key('victim'):
			es.server.cmd(rpgmc[character]['victim'])
		mylist = idlist[event_var['userid']]['items']
		for item in mylist:
			if rpgshop[item]['cfg'] == 'victim':
				es.server.cmd('%s'%rpgshop[item]['cmd'])
	if Players.has_key(event_var['es_attackersteamid']):
		character = Players[event_var['es_attackersteamid']]['character']
		level = Players[event_var['es_attackersteamid']][character]
		for key in rpgmc[character]['skills']:
			if level >= key:
				if rpgmc[character]['skills'][key]['cfg'] == 'attacker':
					es.server.cmd(rpgmc[character]['skills'][key]['cmd'])
		if rpgmc[character].has_key('attacker'):
			es.server.cmd(rpgmc[character]['attacker'])
		mylist = idlist[event_var['userid']]['items']
		for item in mylist:
			if rpgshop[item]['cfg'] == 'attacker':
				es.server.cmd('%s'%rpgshop[item]['cmd'])
def player_spawn(event_var):
	if Players.has_key(event_var['es_steamid']):
		if idlist.has_key(event_var['userid']):
			reset(event_var['userid'])
			character = Players[event_var['es_steamid']]['character']
			level = Players[event_var['es_steamid']][character]
			xp = Players[event_var['es_steamid']]['%sxp'%character]
			xpneeded = level * levelinterval
			es.tell(event_var['userid'], '#multi', '#greenYou are a #lightgreenLevel %i #default: #lightgreen%s #greenXp #default: #green%i #default/ #green%i'%(level, character, xp, xpneeded))
			for key in rpgmc[character]['skills']:
				if level >= key:
					if rpgmc[character]['skills'][key]['cfg'] == 'spawn':
						es.server.cmd(rpgmc[character]['skills'][key]['cmd'])
			if rpgmc[character].has_key('spawn'):
				es.server.cmd(rpgmc[character]['spawn'])
			mylist = idlist[event_var['userid']]['items']
			for item in mylist:
				if rpgshop[item]['cfg'] == 'spawn':
					es.server.cmd('%s'%rpgshop[item]['cmd'])
def bomb_defused(event_var):
	givexp(event_var['userid'], objectivexp, 'defusing the bomb')
def bomb_planted(event_var):
	givexp(event_var['userid'], objectivexp/2, 'planting the bomb')
def bomb_exploded(event_var):
	givexp(event_var['userid'], objectivexp/2, 'defending the bomb till it exploded')
def hostage_rescued(event_var):
	givexp(event_var['userid'], objectivexp/4, 'rescuing a hostage')
def item_pickup(event_var):
	if event_var['item'] != 'c4':
		if Players.has_key(event_var['es_steamid']):
			character = Players[event_var['es_steamid']]['character']
			level = Players[event_var['es_steamid']][character]
			if rpgmc[character].has_key('weapon restriction'):
				type = rpgmc[character]['restriction type']
				weaponlist = rpgmc[character]['weapon restriction']
				if type == 'allow only':
					if event_var['item'] not in weaponlist:
						es.server.queuecmd('est_dropweapon %s weapon_%s'%(event_var['userid'], event_var['item']))
				elif type == 'restrict':
					if event_var['item'] in weaponlist:
						es.server.queuecmd('est_dropweapon %s weapon_%s'%(event_var['userid'], event_var['item']))
def player_activate(event_var):
	global Players
	if not Players.has_key(event_var['es_steamid']):
		Players[event_var['es_steamid']] = {}
		Userkey = Players[event_var['es_steamid']]
		Userkey['name'] = event_var['es_username']
		Userkey['character'] = defaultcharacter
		Userkey[defaultcharacter] = 1
		Userkey['%sxp'%defaultcharacter] = 0
		es.tell(event_var['userid'], '#multi', '#defaultUse #green%s #defaultin chat to select a character to play as!'%menucommand)
	global idlist
	if not idlist.has_key(event_var['userid']):
		idlist[event_var['userid']] = {}
		reset(event_var['userid'])
		idlist[event_var['userid']]['name'] = event_var['es_username']
		idlist[event_var['userid']]['deaths'] = 0
		idlist[event_var['userid']]['items'] = []
def player_disconnect(event_var):
	global idlist
	if idlist.has_key(event_var['userid']):
		del idlist[event_var['userid']]
def player_team(event_var):
	global Players
	if Players.has_key(event_var['es_steamid']):
		character = Players[event_var['es_steamid']]['character']
		if rpgmc[character].has_key('team allowed'):
			Players[event_var['es_steamid']]['character'] = defaultcharacter
			es.tell(event_var['userid'], '#multi', '#defaultYour character has been set to #lightgreen%s #defaultwhen you changed teams.'%defaultcharacter)
def round_start(event_var):
	es.msg('#multi', '#lightgreen[ #green%s Mod #lightgreen] #defaultis Running. #greenUse #lightgreen%s #greenfor a list of commands.'%(modname, helpcommand))
def round_end(event_var):
	global Players
	global idlist
	str_path = open(es.getAddonPath('rpgmaker') + '/Players.db', 'w')
	cPickle.dump(Players, str_path)
	str_path.close()
	for int_userid in player.getUseridList('#all'):
		idlist[str(int_userid)]['deaths'] += 1
	if event_var['winner'] == '2':
		for int_userid in playerlib.getUseridList('#t'):
			givexp(int_userid, endroundxp, 'for winning the round')
	elif event_var['winner'] == '3':
		for int_userid in playerlib.getUseridList('#ct'):
			givexp(int_userid, endroundxp, 'for winning the round')
#End events for RPGMaker

def load():
	es.server.cmd('echo Loading RPGMaker')
	#Create the Character Menu
	global rpgmcmenu
	rpgmcmenu = popuplib.easymenu('rpgmcmenu', '_popup_choice', rpgmcselect)
	rpgmcmenu.settitle('%s Characters:'%modname)
	#This will create a menu that will display information about different characters to people
	global rpgmcinfo
	rpgmcinfo = popuplib.easymenu('rpgmcinfo', '_popup_choice', rpgmcinfoselect)
	rpgmcinfo.settitle('%s Character Information:'%modname)
	counter = 1
	total = 0
	for key in rpgmc:
		total += 1
	while counter <= total:
		for key in rpgmc:
			place = rpgmc[key]['Menu Place']
			if place == counter:
				if rpgmc[key].has_key('required level') and not rpgmc[key].has_key('team allowed'):
					rpgmcmenu.addoption(key, '%s (Required Level %i)'%(key, rpgmc[key]['required level']))
					rpgmcinfo.addoption(key, '%s (Required Level %i)'%(key, rpgmc[key]['required level']))
				elif rpgmc[key].has_key('team allowed') and not rpgmc[key].has_key('required level'):
					allowed = rpgmc[key]['team allowed']
					team = 0
					if allowed == 2:
						team = 'T'
					elif allowed == 3:
						team = 'CT'
					else:
						es.dbgmsg(0, 'RPG team allowed Error: Please use only 2 or 3 as choices for this value!')
					if team:
						rpgmcmenu.addoption(key, '%s (Required Team %s)'%(key, team))
						rpgmcinfo.addoption(key, '%s (Required Team %s)'%(key, team))
				elif rpgmc[key].has_key('required level') and rpgmc[key].has_key('team allowed'):
					allowed = rpgmc[key]['team allowed']
					team = 0
					if allowed == 2:
						team = 'T'
					elif allowed == 3:
						team = 'CT'
					else:
						es.dbgmsg(0, 'RPG team allowed Error: Please use only 2 or 3 as choices for this value!')
					if team:
						rpgmcmenu.addoption(key, '%s (Required: Level %i, Team %s)'%(key, rpgmc[key]['required level'], team))
						rpgmcinfo.addoption(key, '%s (Required: Level %i, Team %s)'%(key, rpgmc[key]['required level'], team))
				else:
					rpgmcmenu.addoption(key, key)
					rpgmcinfo.addoption(key, key)
				counter += 1
	#This creates our shopmenu
	global shopmenu
	global shopinfo
	shopmenu = popuplib.easymenu('shopmenu', '_popup_choice', shopselect)
	shopmenu.settitle('%s Items Menu:'%modname)
	shopinfo = popuplib.easymenu('shopinfo', '_popup_choice', shopinfoselect)
	shopinfo.settitle('Which item do you want to see information about:')
	counter = 1
	total = 0
	for key in rpgshop:
		total += 1
	while counter <= total:
		for key in rpgshop:
			place = rpgshop[key]['Menu Place']
			if place == counter:
				shopmenu.addoption(key, '%s ($%s)'%(key, rpgshop[key]['cost']))
				shopinfo.addoption(key, '%s ($%s)'%(key, rpgshop[key]['cost']))
				counter += 1
	#Lets make a help menu!
	global helpmenu
	helpmenu = popuplib.create('helpmenu')
	helpmenu.addline('%s Text Commands:'%modname)
	helpmenu.addline(' %s - Lets you choose a new character.'%menucommand)
	helpmenu.addline(' %s - Tells you your character, level, and Xp.'%infocommand)
	helpmenu.addline(" %s - Shows what different skills a character has and what they do."%characterinfocommand)
	helpmenu.addline(' %s - Brings up a menu to buy items from.'%shopcommand)
	helpmenu.addline(' %s - Shows information on the items you can buy.'%shopinfocommand)
	helpmenu.addline(' %s - Displays what character and level a selected player is.'%playerinfocommand)
	helpmenu.addline(' %s - This help menu.'%helpcommand)
	#Code to load our player data base if it exists
	str_path = es.getAddonPath('rpgmaker') + '/Players.db'
	if os.path.isfile(str_path):
		global Players
		file_users = open(str_path)
		Players = cPickle.load(file_users)
		file_users.close()
	#Lets create our rpg command that will give our coders lots of fun things to work with
	if not es.exists('command', 'rpg'):
		es.regcmd('rpg', 'rpgmaker/rpgcommand')
	#Lets also let our admins use these commands
	if not es.exists('saycommand', 'rpg'):
		es.regsaycmd('rpg', 'rpgmaker/rpgadmincheck')
	#These following lines set up our chat commands based on what the user sets them to
	if not es.exists('saycommand', menucommand):
		es.regsaycmd(menucommand, 'rpgmaker/sendcharactermenu')
	if not es.exists('saycommand', helpcommand):
		es.regsaycmd(helpcommand, 'rpgmaker/sendhelpmenu')
	if not es.exists('saycommand', characterinfocommand):
		es.regsaycmd(characterinfocommand, 'rpgmaker/sendcharacterinfo')
	if not es.exists('saycommand', infocommand):
		es.regsaycmd(infocommand, 'rpgmaker/xpinfo')
	if not es.exists('saycommand', shopcommand):
		es.regsaycmd(shopcommand, 'rpgmaker/shopsend')
	if not es.exists('saycommand', shopinfocommand):
		es.regsaycmd(shopinfocommand, 'rpgmaker/shopinfosend')
	if not es.exists('saycommand', playerinfocommand):
		es.regsaycmd(playerinfocommand, 'rpgmaker/playerinfo')
	#This defines the server_var(s) that our mod will use
	es.ServerVar('rpg_random').set(0)
	es.ServerVar('rpg_var1').set(0)
	es.ServerVar('rpg_var2').set(0)
	es.ServerVar('rpg_var3').set(0)
	es.ServerVar('rpg_var4').set(0)
	es.ServerVar('rpg_var5').set(0)
	es.ServerVar('rpg_var6').set(0)
	es.ServerVar('rpg_var7').set(0)
	es.ServerVar('rpg_var8').set(0)
	es.ServerVar('rpg_var9').set(0)
	es.ServerVar('rpg_var10').set(0)
	es.ServerVar('player').set(0)
	#Load our extra es_skills.txt that coders may be using with RPGMaker
	es.load('rpgmaker/skills')
	es.server.cmd('echo Loading Finished: RPGMaker up and running.')
#Checks if our user was an admin before we run the command he used in chat
def rpgadmincheck():
	steamid = es.getplayersteamid(es.getcmduserid())
	if steamid in adminlist:
		argcount = es.getargc()
		stringcount = 1
		commandstring = ''
		while stringcount <= argcount:
			addstring = es.getargv(stringcount)
			commandstring = '%s %s'%(commandstring, addstring)
			stringcount += 1
		es.server.queuecmd('rpg %s'%commandstring)
	else:
		es.tell(es.getcmduserid(), '#lightgreen', 'You are not a %s admin!'%modname)
#Block that controls our rpg command
def rpgcommand():
	global idlist
	global Players
	arg1 = es.getargv(1)
	args = es.getargc()
	if arg1 == 'damage':
		if args == 5:
			if playerlib.getPlayer(es.getargv(2)).get('health') >= float(es.getargv(4)):
				es.server.queuecmd('rpg health %s -%s 0'%(es.getargv(2), es.getargv(4)))
			else:
				es.server.queuecmd('damage %s %s 32 %s'%(es.getargv(2), es.getargv(4), es.getargv(3)))
		else:
			es.dbgmsg(0, 'rpg damage <userid> <attacker> <amount>')
	elif arg1 == 'health':
		if args == 5:
			if idlist.has_key(es.getargv(2)):
				id = playerlib.getPlayer(es.getargv(2))
				health = id.get('health')
				maxhealth = idlist[es.getargv(2)]['rpg_maxhealth']
				health += float(es.getargv(3))
				if int(es.getargv(4)):
					idlist[es.getargv(2)]['rpg_maxhealth'] += int(es.getargv(3))
					id.set('health', health)
				else:
					if health <= maxhealth:
						id.set('health', health)
					else:
						id.set('health', maxhealth)
		else:
			es.dbgmsg(0, 'rpg health <userid> <amount> <effect max>')
	elif arg1 == 'givexp':
		if args == 5:
			givexp(es.getargv(2), int(es.getargv(3)), es.getargv(4))
		else:
			es.dbgmsg(0, 'rpg givexp <userid> <amount> <reason>')
	elif arg1 == 'stun':
		if args == 4:
			id = es.getargv(2)
			es.server.queuecmd('est_freeze %s 1'%id)
			gamethread.delayed(int(es.getargv(3)), unfreeze, id)
		else:
			es.dbgmsg(0, 'rpg stun <userid> <duration>')
	elif arg1 == 'god':
		if args == 4:
			id = es.getargv(2)
			es.server.queuecmd('est_god %s 1'%id)
			gamethread.delayed(es.getargv(3), ungod, id)
		else:
			es.dbgmsg(0, 'rpg god <userid> <duration>')
	elif arg1 == 'blind':
		if args == 4:
			es.server.queuecmd('est_fade %s 0 0 %s 0 0 0 255'%(es.getargv(2), es.getargv(3)))
		else:
			es.dbgmsg(0, 'rpg blind <userid> <duration>')
	elif arg1 == 'burn':
		if args == 4:
			es.server.queuecmd('est_burn %s %s'%(es.getargv(2), es.getargv(3)))
		else:
			es.dbgmsg(0, 'rpg burn <userid> <duration>')
	elif arg1 == 'gravity':
		if args == 4:
			if idlist.has_key(es.getargv(2)):
				gravity = idlist[es.getargv(2)]['rpg_gravity']
				gravity += float(es.getargv(3))
				es.server.queuecmd('est_setgravity %s %s'%(es.getargv(2), gravity))
				idlist[es.getargv(2)]['rpg_gravity'] = gravity
		elif args == 5:
			if idlist.has_key(es.getargv(3)):
				if es.getargv(2) == 'set':
					es.server.queuecmd('est_setgravity %s %s'%(es.getargv(3), es.getargv(4)))
					idlist[es.getargv(3)]['rpg_gravity'] = float(es.getargv(4))
		else:
			es.dbgmsg(0, 'rpg gravity <userid> <amount> or rpg gravity set <userid> <amount>')
	elif arg1 == 'speed':
		if args == 4:
			if idlist.has_key(es.getargv(2)):
				speed = idlist[es.getargv(2)]['rpg_speed']
				speed += float(es.getargv(3))
				es.server.queuecmd('est_speed %s %f'%(es.getargv(2), speed))
				idlist[es.getargv(2)]['rpg_speed'] = speed
		else:
			es.dbgmsg(0, 'rpg speed <userid> <amount>')
	elif arg1 == 'color':
		if args == 4:
			if idlist.has_key(es.getargv(2)):
				Userkey = idlist[es.getargv(2)]
				arg3 = es.getargv(3)
				if arg3 == '#blue':
					Userkey['rpg_red'] = 0
					Userkey['rpg_green'] = 0
					Userkey['rpg_blue'] = 255
				elif arg3 == '#teal':
					Userkey['rpg_red'] = 0
					Userkey['rpg_green'] = 255
					Userkey['rpg_blue'] = 255
				elif arg3 == '#green':
					Userkey['rpg_red'] = 0
					Userkey['rpg_green'] = 255
					Userkey['rpg_blue'] = 0
				elif arg3 == '#red':
					Userkey['rpg_red'] = 255
					Userkey['rpg_green'] = 0
					Userkey['rpg_blue'] = 0
				elif arg3 == '#yellow':
					Userkey['rpg_red'] = 255
					Userkey['rpg_green'] = 255
					Userkey['rpg_blue'] = 0
				elif arg3 == '#orange':
					Userkey['rpg_red'] = 255
					Userkey['rpg_green'] = 165
					Userkey['rpg_blue'] = 0
				elif arg3 == '#pink':
					Userkey['rpg_red'] = 255
					Userkey['rpg_green'] = 130
					Userkey['rpg_blue'] = 171
				elif arg3 == '#purple':
					Userkey['rpg_red'] = 191
					Userkey['rpg_green'] = 62
					Userkey['rpg_blue'] = 255
				elif arg3 == '#black':
					Userkey['rpg_red'] = 40
					Userkey['rpg_green'] = 40
					Userkey['rpg_blue'] = 40
				elif arg3 == '#normal':
					Userkey['rpg_red'] = 255
					Userkey['rpg_green'] = 255
					Userkey['rpg_blue'] = 255
				else:
					es.dbgmsg(0, 'rpg color Error: Acceptable Color Choices are: #blue, #green, #teal, #red, #yellow, #orange, #pink, #purple, #black, and #normal')
				es.server.queuecmd('rpg stealth on %s'%es.getargv(2))
		else:
			es.dbgmsg(0, 'rpg color <userid> <color>')
	elif arg1 == 'visible':
		if args == 4:
			if idlist.has_key(es.getargv(2)):
				Userkey = idlist[es.getargv(2)]
				alpha = int(es.getargv(3))*2.55
				if alpha <= 255 and alpha >= 1:
					Userkey['rpg_alpha'] = alpha
					es.server.queuecmd('rpg stealth on %s'%es.getargv(2))
				else:
					es.dbmsg(0, 'rpg visible Error: Please choose a value between 1 and 100 to set as a color percent')
		elif args == 5:
			if idlist.has_key(es.getargv(3)):
				Userkey = idlist[es.getargv(3)]
				alpha = int(es.getargv(4))*2.55
				newcolor = Userkey['rpg_alpha'] + alpha
				if newcolor <= 255 and newcolor >= 1:
					Userkey['rpg_alpha'] = newcolor
					es.server.queuecmd('rpg stealth on %s'%es.getargv(3))
				else:
					es.dbgmsg(0, 'rpg visible Error: You are trying to set someone colors below 1 or above 100 percent!')
		else:
			es.dbgmsg(0, 'rpg visible <userid> <% visible> or rpg visible math <userid> <amount to change by>')
	elif arg1 == 'stealth':
		arg2 = es.getargv(2)
		if idlist.has_key(es.getargv(3)):
			if arg2 == 'on':
				if args == 4:
					Userkey = idlist[es.getargv(3)]
					r = Userkey['rpg_red']
					g = Userkey['rpg_green']
					b = Userkey['rpg_blue']
					alpha = Userkey['rpg_alpha']
					es.server.queuecmd('est_setplayercolor %s %i %i %i %i 1'%(es.getargv(3), r, g, b, alpha))
				else:
					es.dbgmsg(0, 'rpg stealth on <userid>')
			elif arg2 == 'off':
				if args == 5:
					Userkey = idlist[es.getargv(3)]
					r = Userkey['rpg_red']
					g = Userkey['rpg_blue']
					b = Userkey['rpg_green']
					es.server.queuecmd('est_setplayercolor %s %i %i %i 255 1'%(es.getargv(3), r, g, b))
					if int(es.getargv(4)):
						gamethread.delayed(int(es.getargv(4)), restealth, es.getargv(3))
			else:
				es.dbgmsg(0, "rpg stealth Error: Argument 2 must either be 'on' or 'off'")
		else:
			es.dbgmsg(0, 'rpg stealth off <userid> <duration (0 = forever)>')
	elif arg1 == 'cash':
		if args == 4:
			id = playerlib.getPlayer(es.getargv(2))
			id.set('cash', id.get('cash') + int(es.getargv(3)))
		else:
			es.dbgmsg(0, 'rpg cash <userid> <amount>')
	elif arg1 == 'drug':
		if args == 4:
			es.server.queuecmd('est_drug %s %s'%(es.getargv(2), es.getargv(3)))
		else:
			es.dbgmsg(0, 'rpg drug <userid> <duration>')
	elif arg1 == 'model':
		if args == 5:
			arg4 = es.getargv(4)
			modelnumber = 0
			skin = 0
			if arg4 == 'r' or arg4 == 'random':
				modelnumber = random.randrange(3) + 1
			else:
				modelnumber = arg4
			team = es.getargv(3)
			if team == '#t':
				if modelnumber == 1:
					skin = 'player/t_phoenix'
				elif modelnumber == 2:
					skin = 'player/t_leet'
				elif modelnumber == 3:
					skin = 'player/t_guerilla'
				elif modelnumber == 4:
					skin = 'player/t_arctic'
				else:
					es.dbgmsg(0, 'rpg model Error: Only numbers 1-4 are valid options for the 3rd argument')
			elif team == '#c' or team == '#ct':
				if modelnumber == 1:
					skin = 'player/ct_urban'
				elif modelnumber == 2:
					skin = 'player/ct_sas'
				elif modelnumber == 3:
					skin = 'player/ct_gsg9'
				elif modelnumber == 4:
					skin = 'player/ct_gign'
				else:
					es.dbgmsg(0, 'rpg model Error: Only numbers 1-4 are valid options for the 3rd argument')
			else:
				es.dbgmsg(0, 'rpg model Error: The second argument must be #c or #t')
			es.server.queuecmd('est_setmodel %s %s'%(es.getargv(2), skin))
		else:
			es.dbgmsg(0, 'rpg model <userid> <team> <model number or random>')
	elif arg1 == 'regen':
		if args == 5:
			id = es.getargv(2)
			startingdeaths = idlist[id]['deaths']
			regen(id, es.getargv(3), es.getargv(4), startingdeaths)
		else:
			es.dbgmsg(0, 'rpg regen <userid> <amount> <delay>')
	elif arg1 == 'arearegen':
		if args == 6:
			id = es.getargv(2)
			startingdeaths = idlist[id]['deaths']
			arearegen(id, es.getargv(3), es.getargv(5), es.getargv(4), startingdeaths)
		else:
			es.dbgmsg(0, 'rpg arearegen <userid> <amount> <radius> <delay>')
	elif arg1 == 'set':
		if args == 5:
			if idlist.has_key(es.getargv(2)):
				idlist[es.getargv(2)][es.getargv(3)] = es.getargv(4)
			else:
				es.dbgmsg(0, 'rpg set Error: %s is not a valid userid'%es.getargv(2))
		else:
			es.dbgmsg(0, 'rpg set <userid> <key> <value>')
	elif arg1 == 'get':
		if args == 5:
			if idlist.has_key(es.getargv(3)):
				if idlist.has_key(es.getargv(4)):
					es.ServerVar(es.getargv(2)).set(idlist[es.getargv(3)][es.getargv(4)])
				else:
					es.dbgmsg(0, 'rpg get Error: The key %s does not exist!'%es.getargv(4))
			else:
				es.dbgmsg(0, 'rpg get Error: %s is not a valid userid'%es.getargv(2))
		else:
			es.dbgmsg(0, 'rpg get <return var> <userid> <key>')
	elif arg1 == 'cleanuserfile':
		for user in Players:
			Players[user]['safe'] = 0
			for key in rpgmc:
				if Players[user].has_key(key):
					if Players[key] >= safelevel:
						Players[user]['safe'] = 1
		plist = Players.keys()
		for item in plist:
			if not Players[item]['safe']:
				del Players[item]
	elif arg1 == 'levelup':
		userid = es.getargv(2)
		steamid = es.getplayersteamid(userid)
		if Players.has_key(steamid):
			character = Players[steamid]['character']
			Players[steamid][character] += int(es.getargv(3))
			es.tell(userid, '#lightgreen', 'An Admin has given you levels!')
	else:
		es.dbgmsg(0, '%s is not a valid rpg command!'%arg1)
#This block control our area regen command
def arearegen(userid, amount, delay, radius, startingdeaths):
	if es.exists('userid', userid):
		currentdeaths = idlist[userid]['deaths']
		if currentdeaths == startingdeaths:
			team = int(es.getplayerteam(userid))
			if team == 2:
				check = '#t'
			elif team == 3:
				check = '#c'
			es.server.queuecmd('est_near player %s %i %s "es rpg health server_var(player) %i 0"'%(check, radius, userid, amount))
#This block runs our regen command :)
def regen(userid, amount, delay, startingdeaths):
	if es.exists('userid', userid):
		currentdeaths = idlist[userid]['deaths']
		if currentdeaths == startingdeaths:
			es.server.queuecmd('rpg health %s %i 0'%(userid, int(amount)))
			gamethread.delayed(int(delay), regen, (userid, amount, delay, startingdeaths))
#Block that turns the users stealth back on
def restealth(userid):
	es.server.queuecmd('rpg stealth on %s'%userid)
#Block used to turn off the god power for a player
def ungod(userid):
	es.server.queuecmd('est_god %s 0'%userid)
#Block used to unfreeze a player when the rpg stun command is used
def unfreeze(userid):
	es.server.queuecmd('est_freeze %s 0'%userid)
#Method used to default all values for a player - and reset their gravity
def reset(userid):
	global idlist
	if idlist.has_key(str(userid)):
		Userkey = idlist[userid]
		Userkey['rpg_maxhealth'] = 100
		Userkey['rpg_speed'] = 1.0
		Userkey['rpg_gravity'] = 1.0
		Userkey['rpg_red'] = 255
		Userkey['rpg_green'] = 255
		Userkey['rpg_blue'] = 255
		Userkey['rpg_alpha'] = 255
	es.server.queuecmd('rpg color %s #normal'%userid)
	es.server.queuecmd('est_setgravity %s 1'%userid)
#Block used to handle all xp given by the pluggin
def givexp(userid, amount, reason):
	steamid = es.getplayersteamid(userid)
	if Players.has_key(steamid):
		character = Players[steamid]['character']
		xp = Players[steamid]['%sxp'%character] + amount
		level = Players[steamid][character]
		xpneeded = level * levelinterval
		if xp >= xpneeded:
			xp -= xpneeded
			level += 1
			Players[steamid][character] = level
			es.tell(userid, '#multi', '#lightgreenYou have obtained #defaultLevel %s: #green%s'%(level, character))
			if rpgmc[character]['skills'].has_key(level):
				es.tell(userid, '#multi', '#green%s #defaulthas gained the skill #lightgreen%s #defaultfor reaching #lightgreenLevel #green%s'%(character, rpgmc[character]['skills'][level]['name'], level))
		Players[steamid]['%sxp'%character] = xp
		es.tell(userid, '#multi', '#lightgreenYou got #green%i xp #lightgreenfor %s.'%(amount, reason))
#Block used to send our menus to the caller
def sendhelpmenu():
	helpmenu.send(es.getcmduserid())
def sendcharactermenu():
	rpgmcmenu.send(es.getcmduserid())
def sendcharacterinfo():
	rpgmcinfo.send(es.getcmduserid())
def shopsend():
	shopmenu.send(es.getcmduserid())
def shopinfosend():
	shopinfo.send(es.getcmduserid())
#This method is called when the playerinfo command is used
def playerinfo():
	playermenu = popuplib.easymenu('playermenu', '_popup_choice', playerselect)
	playermenu.settitle('Select a Player to see information about:')
	for player in playerlib.getUseridList('#all'):
		name = es.getplayername(player)
		playermenu.addoption(player, name)
	playermenu.send(es.getcmduserid())
def playerselect(userid, choice, popupid):
	steamid = es.getplayersteamid(choice)
	character = Players[steamid]['character']
	level = Players[steamid][character]
	name = es.getplayername(choice)
	es.tell(userid, '#multi', '#lightgreen%s #defaultis a #green%s #defaultand is #lightgreen Level #green%i'%(name, character, level))
#This method displays to our users information about his character, level, and xp
def xpinfo():
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	character = Players[steamid]['character']
	level = Players[steamid][character]
	xp = Players[steamid]['%sxp'%character]
	xpneeded = level * levelinterval
	es.tell(userid, '#multi', '#greenYou are a #lightgreenLevel %i #default: #lightgreen%s #greenXp #default: #green%i #default/ #green%i'%(level, character, xp, xpneeded))
#This method is called when the rpgmcinfomenu is used
def rpgmcinfoselect(userid, choice, popupid):
	infomenu = popuplib.easymenu('infomenu', '_popup_choice', infoselect)
	infomenu.settitle('%s Skills List - Choose one to see information about:'%choice)
	passtuple = ('weapons', choice)
	if rpgmc[choice].has_key('weapon restriction'):
		infomenu.addoption(passtuple, 'Weapon Limitations')
	listskills = rpgmc[choice]['skills'].keys()
	listskills.sort()
	for skill in listskills:
		passtuple = (choice, skill)
		infomenu.addoption(passtuple, '%s - (Level %s)'%(rpgmc[choice]['skills'][skill]['name'], skill))
	infomenu.send(userid)
#This method is called when the internal infomenu is sent
def infoselect(userid, choice, popupid):
	if choice[0] == 'weapons':
		type = rpgmc[choice[1]]['restriction type']
		if type == 'allow only':
			string = '#green%s #defaultMay use the following weapons#lightgreen:'%choice[1]
		elif type == 'restrict':
			string = '#green%s #defaultMay not use the following weapons#lightgreen:'%choice[1]
		color = '#green'
		for item in rpgmc[choice[1]]['weapon restriction']:
			string = '%s %s%s'%(string, color, item)
			if color == '#green':
				color = '#lightgreen'
			elif color == '#lightgreen':
				color = '#default'
			elif color == '#default':
				color = '#green'
		es.tell(userid, '#multi', string)
	else:
		es.tell(userid, '#multi', '#lightgreen%s #default: #green%s'%(rpgmc[choice[0]]['skills'][choice[1]]['name'], rpgmc[choice[0]]['skills'][choice[1]]['description']))
#The Block called when the rpgmcmenu is used
def rpgmcselect(userid, choice, popupid):
	global Players
	rlcheck = 0
	tcheck = 0
	steamid = es.getplayersteamid(userid)
	if rpgmc[choice].has_key('required level'):
		for character in rpgmc:
			if Players[steamid].has_key(character):
				if Players[steamid][character] >= rpgmc[choice]['required level']:
					rlcheck = 1
	else:
		rlcheck = 1
	if rpgmc[choice].has_key('team allowed'):
		team = es.getplayerteam(userid)
		if team == rpgmc[choice]['team allowed']:
			tcheck = 1
	else:
		tcheck = 1
	if rlcheck :
		if tcheck:
			if playerlib.getPlayer(userid).get('isdead'):
				if not Players[steamid].has_key(choice):
					Players[steamid][choice] = 1
					Players[steamid]['%sxp'%choice] = 0
				Players[steamid]['character'] = choice
				es.tell(userid, '#multi', '#greenYou are now a #lightgreen%s'%choice)
			else:
				es.tell(userid, '#multi', '#lightgreenYou need to be dead to change character!')
		else:
			es.tell(userid, '#multi', '#lightgreenYou are not on the correct team to play that selection!')
	else:
		es.tell(userid, '#multi', '#lightgreenYou do not have a high enough level to use that selection!')
#Block called when the rpgshopmenu is used
def shopselect(userid, choice, popupid):
	global idlist
	items = 0
	for item in idlist[str(userid)]['items']:
		items += 1
	if items < maxitems:
		if playerlib.getPlayer(userid).get('isdead') == rpgshop[choice]['isdead'] or rpgshop[choice]['isdead'] == 2:
			cash = int(playerlib.getPlayer(userid).get('cash'))
			cost = rpgshop[choice]['cost']
			if cash >= cost:
				playerlib.getPlayer(userid).set('cash', cash - cost)
				if rpgshop[choice].has_key('onbuycmd'):
					es.server.queuecmd('%s'%rpgshop[choice]['onbuycmd'])
				if rpgshop[choice]['cfg'] == 'onbuy':
					es.server.queuecmd('%s'%rpgshop[choice]['cmd'])
				else:
					idlist[str(userid)]['items'].append(choice)
				es.tell(userid, '#multi', '#green%s #defaultPurchased'%choice)
			else:
				es.tell(userid, '#lightgreen', 'You do not have enough cash to purchase that item.')
	else:
		es.tell(userid, '#lightgreen', 'You already have the maximum number of items a player may carry.')
#This method is called when shopinfo is used
def shopinfoselect(userid, choice, popupid):
	es.tell(userid, '#multi', '#lightgreen%s #default: #green%s'%(choice, rpgshop[choice]['description']))
